#include "1-Wire.h"
#include "gpio.h"
#include "delays.h"

unsigned int One_Wire_Reset(unsigned long PIN)								
{
	unsigned int tmp;
	PIN_IN(PIN);
	if ((PIN_SYG(PIN))==0)
	{
		return One_Wire_Bus_Low_Error;
	}
	PIN_OUT(PIN);
	PIN_OFF(PIN);
	delay_us(Time_Reset_Low);
	PIN_ON(PIN);
	PIN_IN(PIN);
	delay_us(Time_Pulse_Delay_High);
	if ((PIN_SYG(PIN))==0)
		{tmp=One_Wire_Success;}
	else
		{tmp=One_Wire_Error_No_Echo;}
	delay_us(Time_After_Reset);
	return tmp;
}

void One_Wire_Write_Byte(unsigned char Byte,unsigned long PIN)
{
	unsigned char cnt=0;
	while (cnt!=8)
	{
		One_Wire_Write_Bit(Byte&(1<<cnt),PIN);
		cnt++;
	}
}

void One_Wire_Write_Bit (unsigned char Bit,unsigned long PIN)
{
	PIN_OUT(PIN);
	PIN_OFF(PIN);
	if (Bit==0)
	{
		delay_us(Time_Pulse_Delay_High);
		PIN_ON(PIN);
		delay_us(Time_Pulse_Delay_Low);
	}
	else
	{
		delay_us(Time_Pulse_Delay_Low);
		PIN_ON(PIN);
		delay_us(Time_Pulse_Delay_High);
	}
	PIN_IN(PIN);
} 

unsigned char One_Wire_Read_Byte(unsigned long PIN)
{
	unsigned char tmp=0;
	unsigned char cnt=0;
	while (cnt!=8)
	{
		if (One_Wire_Read_Bit(PIN)!=0)
			{
				tmp|=(1<<cnt);
			}
		cnt++;
	}
	delay_us(Time_Pulse_Delay_High);
	return tmp;
}

unsigned char One_Wire_Read_Bit (unsigned long PIN)
{
		unsigned char tmp;
	 	PIN_OUT(PIN);
		PIN_OFF(PIN);
		delay_us(Time_Hold_Down);
		PIN_IN(PIN);
		delay_us(Time_Pulse_Delay_Low);
		if ((PIN_SYG(PIN))!=0)
		{
			tmp = 1;
		}
		else
		{	
			tmp = 0;
		}
		delay_us(Time_Pulse_Delay_High);
		return tmp;
}
